Blockly.Blocks['speed'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("はしれ");
    this.appendDummyInput()
        .appendField("アドレス")
        .appendField(new Blockly.FieldNumber(3, 1, 9999), "LOC_ADDR");
    this.appendDummyInput()
        .appendField("速度")
        .appendField(new Blockly.FieldNumber(0, 0, 100), "LOC_SPEED")
        .appendField("%");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(230);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['speedx'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("はしれ");
    this.appendValueInput("inAddr")
        .setCheck("Number")
        .appendField("アドレス")
    this.appendValueInput("inSpeed")
        .setCheck("Number")
        .appendField("速度")
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(230);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['direction'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("走る向き");
    this.appendDummyInput()
        .appendField("アドレス")
        .appendField(new Blockly.FieldNumber(3, 1, 9999), "LOC_ADDR");
    this.appendDummyInput()
        .appendField("向き")
        .appendField(new Blockly.FieldDropdown([["まえ","1"], ["うしろ","2"]]), "LOC_DIR");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(230);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['directionx'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("走る向き");
    this.appendValueInput("inAddr")
        .setCheck("Number")
        .appendField("アドレス")
    this.appendValueInput("inDir")
        .setCheck("Number")
        .appendField("向き")
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(230);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['turnout'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("ポイント");
    this.appendDummyInput()
        .appendField("アドレス")
        .appendField(new Blockly.FieldNumber(1, 1, 2048), "ACC_ADDR");
    this.appendDummyInput()
        .appendField("向き")
        .appendField(new Blockly.FieldDropdown([["まっすぐ","1"], ["ぶんき","0"]]), "ACC_DIR");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(315);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['turnoutx'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("ポイント");
    this.appendValueInput("inAddr")
        .setCheck("Number")
        .appendField("アドレス")
    this.appendValueInput("inDir")
        .setCheck("Number")
        .appendField("向き")
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(315);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['locfunction'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("機能");
    this.appendDummyInput()
        .appendField("アドレス")
        .appendField(new Blockly.FieldNumber(3, 1, 9999), "LOC_ADDR");
    this.appendDummyInput()
        .appendField("F")
        .appendField(new Blockly.FieldNumber(0, 0, 28), "NAME");
    this.appendDummyInput()
        .appendField("そうさ")
        .appendField(new Blockly.FieldCheckbox("TRUE"), "FUNC_VAL");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(230);
 this.setTooltip("loco function");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['locfunction2'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("機能モメンタリ");
    this.appendDummyInput()
        .appendField("アドレス")
        .appendField(new Blockly.FieldNumber(3, 1, 9999), "LOC_ADDR");
    this.appendDummyInput()
        .appendField("F")
        .appendField(new Blockly.FieldNumber(0, 0, 28), "NAME");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(230);
 this.setTooltip("モーメンタリそうさのファンクションです。");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['locfunctionx'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("機能");
    this.appendValueInput("inAddr")
        .setCheck("Number")
        .appendField("アドレス")
    this.appendValueInput("inFuncNo")
        .setCheck("Number")
        .appendField("F")
    this.appendValueInput("inFuncVal")
        .setCheck("Number")
        .appendField("そうさ")
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(230);
 this.setTooltip("loco function");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['getslotspeed'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("スロット速度")
        .appendField(new Blockly.FieldDropdown([["スロット1","0"], ["スロット2","1"], ["スロット3","2"], ["スロット4","3"]]), "SLOT_NO");
    this.setInputsInline(true);
    this.setOutput(true, "Number");
    this.setColour(270);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['waitsleep'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("待つ")
        .appendField(new Blockly.FieldNumber(1, 1, 100000), "WAIT_TIME")
        .appendField("秒");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(180);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['s88start'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("在線センサかいし");
    this.setInputsInline(true);
    this.setColour(260);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['s88get'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("在線センサ")
        .appendField(new Blockly.FieldNumber(1, 1, 16), "S88_ADDR");
    this.setInputsInline(true);
    this.setOutput(true, null);
    this.setColour(260);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['s88getx'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("在線センサ");
    this.appendValueInput("PRM_S88")
        .setCheck("Number");
    this.setInputsInline(true);
    this.setOutput(true, null);
    this.setColour(260);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['getslotaddr'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("スロットアドレス")
        .appendField(new Blockly.FieldDropdown([["スロット1","0"], ["スロット2","1"], ["スロット3","2"], ["スロット4","3"]]), "SLOT_NO");
    this.setInputsInline(true);
    this.setOutput(true, "Number");
    this.setColour(270);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['stop_funcx'] = {
  init: function() {
    this.appendValueInput("PRM_STOP")
        .setCheck("Number")
        .appendField("とまれ")
        .appendField("アドレス");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(230);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['stop_func'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("とまれ")
        .appendField("アドレス")
        .appendField(new Blockly.FieldNumber(3, 1, 9999), "LOCADDR");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(230);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['playmp3'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("MP3をならす")
        .appendField(new Blockly.FieldTextInput("test.mp3"), "MP3FILE");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(90);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['playmp3list'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("音をだす")
        .appendField(new Blockly.FieldDropdown([["けいてき1","horn1.mp3"], ["けいてき2","horn2.mp3"], ["きてき","C61Whistle.mp3"], ["笛","whistle.mp3"], ["ブレーキ","break.mp3"], ["ふみきり","fumikiri.mp3"], ["ドア開","door_open.mp3"], ["ドア閉","door_close.mp3"], ["ドア開2","door_open2.mp3"], ["セレナーデ","Heykens.mp3"]]), "MP3FILE");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(90);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['stopmp3'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("音をとめる");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(90);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['beginthis'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("プログラム始まり");
    this.setInputsInline(true);
    this.setPreviousStatement(false, null);
    this.setNextStatement(true, null);
    this.setColour(180);
 this.setTooltip("プログラムを始めます");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['exitthis'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("プログラム終わり");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(false, null);
    this.setColour(180);
 this.setTooltip("プログラムを終わらせます");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['getslotfnc'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("スロット機能");
    this.appendDummyInput()
        .appendField(new Blockly.FieldDropdown([["スロット1","0"], ["スロット2","1"], ["スロット3","2"], ["スロット4","3"]]), "SLOTNO")
        .appendField("番号")
        .appendField(new Blockly.FieldNumber(0, 0, 28), "LOC_FNC");
    this.setInputsInline(true);
    this.setOutput(true, "Number");
    this.setColour(270);
 this.setTooltip("スロットの機能がオンかどうかチェックします");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['powerx'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("でんげん");
    this.appendValueInput("inPwr")
        .setCheck("Number")
        .appendField("そうさ");
   this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(320);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['power'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("でんげん")
        .appendField(new Blockly.FieldDropdown([["オフ","0"], ["オン","1"]]), "PWR_VAL");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(320);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['analogpwm'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("PWM");
    this.appendDummyInput()
        .appendField("つよさ")
        .appendField(new Blockly.FieldNumber(0, 0, 100), "VAL_DUTY")
        .appendField("%");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(220);
 this.setTooltip("アナログPWMをだします。");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['analogdir'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("PWM");
    this.appendDummyInput()
        .appendField("むき")
        .appendField(new Blockly.FieldNumber(1, 1, 2), "VAL_DIR");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(220);
 this.setTooltip("アナログPWMきのうのむきを決めます");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['ChangeProtocolMM2'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("MM2モードにする");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(170);
 this.setTooltip("プロトコルをMM2にします");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['ChangeProtocolDCC'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("DCCモードにする");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(170);
 this.setTooltip("プロトコルをDCCにします");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['show_deco'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("でーこちゃんに来てもらう");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(170);
 this.setTooltip("でーこちゃんを表示します");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['say_deco'] = {
  init: function() {
    this.appendDummyInput()
        .appendField(new Blockly.FieldTextInput("うーん"), "SAYTEXT")
        .appendField("と言う");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(10);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['say_decox'] = {
  init: function() {
    this.appendValueInput("inText")
        .setCheck("Text")    
    this.appendDummyInput()
        .appendField("と言う");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(10);
 this.setTooltip("");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['excr_deco'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("おどろく");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(10);
 this.setTooltip("でーこちゃんがおどろきます");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['show_deco'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("でーこちゃんが来る");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(10);
 this.setTooltip("でーこちゃんを表示します");
 this.setHelpUrl("");
  }
};

Blockly.Blocks['close_deco'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("でーこちゃんが帰る");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(10);
 this.setTooltip("でーこちゃんを非表示します");
 this.setHelpUrl("");
  }
};